
QGIS Application - Bug report #15060

Error when creating Help Files of Models in Processing

2016-06-18 02:16 AM - matteo ghetta

Status: Closed

Priority: Normal

Assignee: Victor Olaya

Category: Processing/Modeller

Affected QGIS version:2.14.3 Regression?: No

Operating System: debian Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 23003

Description

I have some models that I want to improve the Help. When clicking on the button in the edit model (same error with a new model).

It seems the error appears just when the model has some R scripts inside.

This the error:

An error has occurred while executing Python code:

TypeError: object.__new__(NotImplementedType) is not safe, use NotImplementedType.__new__()

Traceback (most recent call last):

  File "/home/matteo/.qgis2/python/plugins/processing/modeler/ModelerDialog.py", line 230, in editHelp

    alg = self.alg.getCopy()

  File "/home/matteo/.qgis2/python/plugins/processing/modeler/ModelerAlgorithm.py", line 212, in getCopy

    newone.algs = copy.deepcopy(self.algs)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 298, in _deepcopy_inst

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 298, in _deepcopy_inst

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 190, in deepcopy

    y = _reconstruct(x, rv, 1, memo)

  File "/usr/lib/python2.7/copy.py", line 334, in _reconstruct

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy
    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 230, in _deepcopy_list

    y.append(deepcopy(a, memo))

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 298, in _deepcopy_inst

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 190, in deepcopy

    y = _reconstruct(x, rv, 1, memo)

  File "/usr/lib/python2.7/copy.py", line 334, in _reconstruct

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 190, in deepcopy

    y = _reconstruct(x, rv, 1, memo)

  File "/usr/lib/python2.7/copy.py", line 334, in _reconstruct

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 190, in deepcopy

    y = _reconstruct(x, rv, 1, memo)

  File "/usr/lib/python2.7/copy.py", line 334, in _reconstruct

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 230, in _deepcopy_list

    y.append(deepcopy(a, memo))

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 298, in _deepcopy_inst

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)
  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 190, in deepcopy

    y = _reconstruct(x, rv, 1, memo)

  File "/usr/lib/python2.7/copy.py", line 334, in _reconstruct

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 190, in deepcopy

    y = _reconstruct(x, rv, 1, memo)

  File "/usr/lib/python2.7/copy.py", line 329, in _reconstruct

    y = callable(*args)

  File "/usr/lib/python2.7/copy_reg.py", line 93, in newobj

    return cls._new__(cls, *args)

TypeError: object.__new__(NotImplementedType) is not safe, use NotImplementedType.__new__()

Versione Python: 2.7.9 (default, Mar  1 2015, 13:01:26) [GCC 4.9.2]

Versione di QGIS: 2.15.0-Master Master, 3d941e3

Related issues:

Duplicated by QGIS Application - Bug report # 15480: processing modeler: 'run... Rejected 2016-08-23

Associated revisions

Revision f7c639c1 - 2016-10-04 09:25 AM - Victor Olaya

[processing] alternative way of copying algorithms in a model.

should fix #15060 and #15480

Revision 22a6c473 - 2016-10-18 03:55 PM - Victor Olaya

[processing] alternative way of copying algorithms in a model.

should fix #15060 and #15480

History

#1 - 2016-08-13 04:04 PM - Randal Hale

I just duplicated (I think) in 2.16.1 on Xubuntu 16.04. I'm getting the following error: 

An error has occurred while executing Python code:

TypeError: can't pickle NotImplementedType objects 

Traceback (most recent call last):

  File "/usr/share/qgis/python/plugins/processing/modeler/ModelerDialog.py", line 230, in editHelp

    alg = self.alg.getCopy()
  File "/usr/share/qgis/python/plugins/processing/modeler/ModelerAlgorithm.py", line 212, in getCopy

    newone.algs = copy.deepcopy(self.algs)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 298, in _deepcopy_inst

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 298, in _deepcopy_inst

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 190, in deepcopy

    y = _reconstruct(x, rv, 1, memo)

  File "/usr/lib/python2.7/copy.py", line 334, in _reconstruct

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 230, in _deepcopy_list

    y.append(deepcopy(a, memo))

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 298, in _deepcopy_inst

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 190, in deepcopy

    y = _reconstruct(x, rv, 1, memo)

  File "/usr/lib/python2.7/copy.py", line 334, in _reconstruct

    state = deepcopy(state, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict

    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 163, in deepcopy

    y = copier(x, memo)

  File "/usr/lib/python2.7/copy.py", line 257, in _deepcopy_dict
    y[deepcopy(key, memo)] = deepcopy(value, memo)

  File "/usr/lib/python2.7/copy.py", line 182, in deepcopy

    rv = reductor(2)

TypeError: can't pickle NotImplementedType objects

Python version: 2.7.12 (default, Jul  1 2016, 15:12:24) [GCC 5.4.0 20160609] 

QGIS version: 2.16.1-Nødebo Nødebo, 8545b3b

Python Path:

/usr/share/qgis/python/plugins/processing

/usr/share/qgis/python

/home/rjhale/.qgis2/python

/home/rjhale/.qgis2/python/plugins

/usr/share/qgis/python/plugins

/usr/lib/python2.7

/usr/lib/python2.7/plat-x86_64-linux-gnu

/usr/lib/python2.7/lib-tk

/usr/lib/python2.7/lib-old

/usr/lib/python2.7/lib-dynload

/home/rjhale/.local/lib/python2.7/site-packages

/usr/local/lib/python2.7/dist-packages

/usr/lib/python2.7/dist-packages

/usr/lib/python2.7/dist-packages/PILcompat

/usr/lib/python2.7/dist-packages/gtk-2.0

/usr/lib/python2.7/dist-packages/wx-3.0-gtk2

/home/rjhale/.qgis2//python

/home/rjhale

#2 - 2016-10-04 03:09 AM - Victor Olaya

- Status changed from Open to Closed

Fixed in changeset commit:"f7c639c169b4b96aa963d8a7effc9723e8bc34a7".
